package com.lideeyunji.service.infra.service;

import com.lideeyunji.service.infra.controller.vo.db.DataSourceConfigSaveReqVO;
import com.lideeyunji.service.infra.entity.DataSourceConfigDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 数据源配置 Service 接口
 *
 * @author 金灯剑客
 */
public interface IDataSourceConfigService {

    //初始化连接池
    void initDataSource2Pool();

    boolean codeIsExist(String code);
    /**
     * 创建数据源配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createDataSourceConfig(@Valid DataSourceConfigSaveReqVO createReqVO);

    /**
     * 更新数据源配置
     *
     * @param updateReqVO 更新信息
     */
    void updateDataSourceConfig(@Valid DataSourceConfigSaveReqVO updateReqVO);

    /**
     * 删除数据源配置
     *
     * @param id 编号
     */
    void deleteDataSourceConfig(Long id);

    /**
     * 获得数据源配置
     *
     * @param id 编号
     * @return 数据源配置
     */
    DataSourceConfigDO getDataSourceConfig(Long id);

    DataSourceConfigDO getDataSourceConfigByCode(String code);

    /**
     * 获得数据源配置列表
     *
     * @return 数据源配置列表
     */
    List<DataSourceConfigDO> getDataSourceConfigList();

    //校验是否可以连接
    void validateConnectionOK(DataSourceConfigDO config);

    //是否连接
    boolean isConnect(String dbCode);
}
